> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.agentphone.ai/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.agentphone.ai/_mcp/server.

# Create Number

POST https://api.agentphone.ai/v1/numbers
Content-Type: application/json

Provision a new phone number from the account's configured SMS provider
(or an iMessage line with type=imessage). Optional externalId tags the
number with your own identifier; see PATCH /v1/numbers/\{id}.

Reference: https://docs.agentphone.ai/api-reference/numbers/create-number-v-1-numbers-post

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Headers

- `X-Sub-Account-Id` (string, optional) — Target a sub-account. Pass a sub-account ID to scope this request. Omit to use the master account.

### Body (application/json)

This endpoint expects a CreateNumberRequest.

- `country` (string, optional, default: US)
- `areaCode` (string, optional, nullable)
- `agentId` (string, optional, nullable)
- `externalId` (string, optional, nullable)
- `type` (enum, optional, nullable)
  - Allowed values: `sms`, `imessage`
- `imessageType` (enum, optional, nullable)
  - Allowed values: `inbound`, `outbound`

## Response

### 200

Successful Response

- `id` (string, required)
- `phoneNumber` (string, required)
- `country` (string, required)
- `status` (string, required)
- `createdAt` (datetime, required)
- `type` (string, optional, default: sms)
- `agentId` (string, optional, nullable)
- `outboundSms` (enum, optional, default: enabled)
  - Allowed values: `enabled`, `activating`, `registration_required`
- `inboundCallsEnabled` (boolean, optional, default: true)
- `readReceiptsEnabled` (boolean, optional, default: true)
- `whatsappEnabled` (boolean, optional, default: false)
- `dailyNewContacts` (DailyNewContactsUsage, optional, nullable)
- `externalId` (string, optional, nullable)
- `purchasedAt` (datetime, optional, nullable)

## Errors

### 422 Unprocessable Entity Error

Validation Error

- `detail` (list of ValidationError, optional)

## Types

### DailyNewContactsUsage

- `used` (integer, required)
- `limit` (integer, optional, nullable)

### ValidationError

- `loc` (list of ValidationErrorLocItems, required)
- `msg` (string, required)
- `type` (string, required)

### ValidationErrorLocItems

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "id": "string",
  "phoneNumber": "string",
  "country": "string",
  "status": "string",
  "createdAt": "2024-01-15T09:30:00Z",
  "type": "sms",
  "agentId": "string",
  "outboundSms": "enabled",
  "inboundCallsEnabled": true,
  "readReceiptsEnabled": true,
  "whatsappEnabled": false,
  "dailyNewContacts": {
    "used": 1,
    "limit": 1
  },
  "externalId": "string",
  "purchasedAt": "2024-01-15T09:30:00Z"
}
```

**SDK Code**

```python
import requests

url = "https://api.agentphone.ai/v1/numbers"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.agentphone.ai/v1/numbers';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.agentphone.ai/v1/numbers"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.agentphone.ai/v1/numbers")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.agentphone.ai/v1/numbers")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.agentphone.ai/v1/numbers', [
  'body' => '{}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.agentphone.ai/v1/numbers");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.agentphone.ai/v1/numbers")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```